#ifndef DATA_H
#define DATA_H

enum {
	EV_START = 0,
	EV_DONE,
	EV_ABORT,
	EV_MAX
};

struct s_event {
	int enabled;			/* is event enabled ? */
	char *cmd;			/* shell command */
};

struct s_profile {
	char *name;			/* profile name */
	unsigned long time;		/* time in seconds */
	struct s_event event[EV_MAX];	/* event list */
	int wmcdclock_enabled;		/* set wmcdclock's timer */
	char *wmcdclock_fifo;		/* where wmcdclock listen */
	char *note;			/* some text for user - I had a lot of space in dialog :) */
};

extern struct s_profile *active_profile;

struct s_profile *data_create();
int data_get_second(struct s_profile *item);
int data_get_hour(struct s_profile *item);
int data_get_minute(struct s_profile *item);
struct s_profile *data_load ();
int data_save (struct s_profile *item);
void data_destroy (struct s_profile *item);

#endif
