/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>

#include "interface.h"
#include "support.h"
#include "data.h"
#include "gui.h"

#define USE_FORK 	1

GtkWidget *start_dialog = NULL;
GtkWidget *progress_dialog = NULL;
GtkWidget *done_dialog = NULL;
int end_time = 0, start_time = 0;

void run_event(int id) {
	FILE *f;
	char *name;
	
	/*
	printf("run_event: (%d) %s\n", active_profile->event[id].enabled,
			active_profile->event[id].cmd);
	*/

	if ((id == EV_ABORT || id == EV_START) && active_profile->wmcdclock_enabled) {
		if (active_profile->wmcdclock_fifo[0] == '~' && active_profile->wmcdclock_fifo[1] == '/') {
			name = (char *) malloc(strlen(getenv("HOME")) + strlen(active_profile->wmcdclock_fifo) + 2);
			strcpy(name, getenv("HOME"));
			strcat(name, "/");
			strcat(name, active_profile->wmcdclock_fifo + 2);
		} else {
			name = (char *) malloc(strlen(active_profile->wmcdclock_fifo) + 2);
			strcpy(name, active_profile->wmcdclock_fifo);
		}

		/* printf("fifo: %s\n", name); */
		
		if ((f = fopen(name, "w"))) {
			fprintf(f, "+%02d:%02d:%02d\n",
					id == EV_START ? data_get_hour(active_profile) : 0,
					id == EV_START ? data_get_minute(active_profile) : 0,
					id == EV_START ? data_get_seconds(active_profile) : 0);
			fclose(f);
		}
	}

	if (active_profile->event[id].enabled) {
#if USE_FORK == 1
		switch (fork()) {
			case 0:  /* child */
#endif
				system(active_profile->event[id].cmd);
#if USE_FORK == 1
				exit(0);
				break;
			case -1: /* error */
				perror("fork");
				break;
			default: /* parent */
				break;
		}
#endif
	}
}

int
main (int argc, char *argv[])
{
	struct s_profile *active;

#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

	start_dialog = create_start_dialog ();
	fill_start_dialog();
	
	if (gtk_dialog_run(GTK_DIALOG(start_dialog)) == GTK_RESPONSE_OK) {
		gtk_widget_destroy(start_dialog);
		
		progress_dialog = create_progress_dialog();
		run_event(EV_START);
		start_timer(active_profile->time, active_profile->name);
		
		if(gtk_dialog_run(GTK_DIALOG(progress_dialog)) == GTK_RESPONSE_OK) {
			gtk_widget_destroy(progress_dialog);
			run_event(EV_DONE);
			done_dialog = create_done_dialog();
			gtk_dialog_run(GTK_DIALOG(done_dialog));
		} else {
			gtk_widget_destroy(progress_dialog);
			run_event(EV_ABORT);
		}
	}

	return 0;
}

